
/******************************************************************************
* MODULE     : keyw_case.cc
* DESCRIPTION: cases
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <single.hh>
namespace mmx {

void
evaluator_rep::evaluate_case_1 () {
  // INPUT: (case_1, ...)
  cur= car(trace)[1];
  rem= cons (KW_CASE_2, car(trace)[2], rem);
  // OUTPUT: (expr, case_2, cases, ...)
}

void
evaluator_rep::evaluate_case_2 () {
  // INPUT: (case_2, expr, cases, cont, ...)
  list cases= as_list (cadr (rem));
  if (nil (cases)) {
    cur= caddr (rem);
    rem= cons (VAL_NONE, cdddr (rem));
    // OUTPUT: (cont, void, ...)
    trace= cdr (trace);
  }
  else {
    generic tag= car (cases);
    if (is_func (tag, MMX_ELSE, 1)) {
      cur= tag[1];
      rem= cddr (rem);
      // OUTPUT: (else_body, cont, ...)
      trace= cdr (trace);
    }
    else {
      cur= KW_CASE_3;
      rem= cons (car (rem), tag[0], cdr (rem));
      // OUTPUT: (case_3, expr, matches, cases, cont, ...)
      evaluate_case_3 ();
    }
  }
}

void
evaluator_rep::evaluate_case_3 () {
  // INPUT: (case_3, expr, matches, cases, cont, ...)
  list matches= as_list (cadr (rem));
  if (nil (matches)) {
    cur= KW_CASE_2;
    rem= cons (car (rem), cdr (caddr (rem)), cdddr (rem));
    // OUTPUT: (case_2, expr, other_cases, cont, ...)
    evaluate_case_2 ();
  }
  else {
    generic test= list (MMX_EQUAL, car (rem), car (matches));
    cur= list (MMX_TRANSTYPE, test, VAL_BOOL);
    rem= cons (KW_CASE_4, car (rem), cdr (rem));
    // OUTPUT: (test, case_4, expr, matches, cases, cont, ...)
  }
}

void
evaluator_rep::evaluate_case_4 () {
  // INPUT: (case_4, match?, expr, matches, cases, cont, ...)
  if (as_bool (as_value (car (rem)) -> val)) {
    generic tag= car (cadddr (rem));
    cur= tag[1];
    rem= cddddr (rem);
    // OUTPUT: (match_body, cont, ...)
    trace= cdr (trace);
  }
  else {
    cur= KW_CASE_3;
    rem= cons (cadr (rem), cdr (caddr (rem)), cdddr (rem));
    // OUTPUT: (case_3, expr, other_matches, cases, cont, ...)
    evaluate_case_3 ();
  }
}

} // namespace mmx
