
/******************************************************************************
* MODULE     : keyw_if.cc
* DESCRIPTION: The 'if' keyword
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <single.hh>
namespace mmx {

void
evaluator_rep::evaluate_if_1 () {
  generic cond= cadr (as_list (car (trace)));
  evaluate_arg (list (MMX_TRANSTYPE, cond, VAL_BOOL), KW_IF_2);
}

void
evaluator_rep::evaluate_if_2 () {
  // INPUT: (if_2, evaled_cond, cont, ...)
  bool cond= as_bool (as_value (car (rem)) -> val);
  list orig= as_list (car (trace));
  if (cond) {
    cur= caddr (orig);
    rem= cdr (rem);
    // OUTPUT: (yes_part, cont, ...)
  }
  else if (N (orig) == 4) {
    cur= cadddr (orig);
    rem= cdr (rem);
    // OUTPUT: (no_part, cont, ...)
  }
  else {
    cur= cadr (rem);
    rem= cons (VAL_NONE, cddr (rem));
    // OUTPUT: (cont, void, ...)
  }
  trace= cdr (trace);
}

} // namespace mmx
