
/******************************************************************************
* MODULE     : symbols.cc
* DESCRIPTION: frequently used symbols
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <symbols.hh>
namespace mmx {

/******************************************************************************
* Mathemagix keyword names
******************************************************************************/

symbol MMX_ACCESS (".[]");
symbol MMX_AND ("&&");
symbol MMX_ASSIGN (":=");
symbol MMX_BEGIN ("begin!");
symbol MMX_CASE ("case!");
symbol MMX_COMPOSE ("@");
symbol MMX_CROSS ("Cross"); // added
symbol MMX_DECLARE ("declare!");
symbol MMX_DEFINE ("==");
symbol MMX_DEFINEALIAS (":==");
symbol MMX_DOLLAR ("$");
symbol MMX_DOT (".");
symbol MMX_DOTS ("..");
symbol MMX_ELSE ("else!");
symbol MMX_EQUAL ("=");
symbol MMX_EQUIV ("<=>");
symbol MMX_ERROR ("error!");
symbol MMX_EXISTS ("exists!");
symbol MMX_EXPORT ("export!");
symbol MMX_FACTORIAL (".!");
symbol MMX_FOR ("for!");
symbol MMX_FORALL ("forall!");
symbol MMX_FUNCTION ("->"); // added
symbol MMX_GTR (">");
symbol MMX_GTREQ (">=");
symbol MMX_GTRGTR (">>");
symbol MMX_HAS ("has!");
symbol MMX_HOLDS ("holds!");
symbol MMX_IF ("if!");
symbol MMX_IMPLIES ("=>");
symbol MMX_IMPORT ("import!");
symbol MMX_LAMBDA ("lambda!");
symbol MMX_LESS ("<");
symbol MMX_LESSEQ ("<=");
symbol MMX_LESSLESS ("<<");
symbol MMX_LOCAL ("local!");
symbol MMX_LOOP ("loop!");
symbol MMX_MIGRATE ("migrate!");
symbol MMX_MODIFY ("mod!");
symbol MMX_MINUS ("-");
symbol MMX_MINUSASSIGN ("-=");
symbol MMX_NOT ("!");
symbol MMX_NOTGTR ("!>");
symbol MMX_NOTGTREQ ("!>=");
symbol MMX_NOTLESS ("!<");
symbol MMX_NOTLESSEQ ("!<=");
symbol MMX_NUMBER ("#");
symbol MMX_OMINUS ("@-");
symbol MMX_OOVER ("@/");
symbol MMX_OPLUS ("@+");
symbol MMX_OR ("||");
symbol MMX_OTIMES ("@*");
symbol MMX_OVER ("/");
symbol MMX_OVERASSIGN ("/=");
symbol MMX_PLUS ("+");
symbol MMX_PLUSASSIGN ("+=");
symbol MMX_POSTDEC (".--");
symbol MMX_POSTINC (".++");
symbol MMX_POWER ("^");
symbol MMX_PREDEC ("--");
symbol MMX_PREINC ("++");
symbol MMX_PRIME ("'");
symbol MMX_SEQAND ("and!");
symbol MMX_SEQOR ("or!");
symbol MMX_SQTUPLE ("[]");
symbol MMX_STEP ("step!");
symbol MMX_TIMES ("*");
symbol MMX_TIMESASSIGN ("*=");
symbol MMX_TRANSTYPE (":>");
symbol MMX_TUPLE ("tuple!");
symbol MMX_TYPE (":");
symbol MMX_UNEQUAL ("!=");
symbol MMX_UNTIL ("until!");
symbol MMX_WHILE ("while!");
symbol MMX_XOR ("^^");

/******************************************************************************
* Mathemagix types
******************************************************************************/

symbol MMX_CLASS ("Class");
symbol MMX_GENERIC ("Generic");
symbol MMX_BOOL ("Bool");
symbol MMX_INT ("Int");
symbol MMX_STRING ("String");
symbol MMX_OSTREAM ("Ostream");
symbol MMX_ALIAS ("Alias");

mirror ID_CLASS (MMX_CLASS);
mirror ID_GENERIC (MMX_GENERIC);
mirror ID_BOOL (MMX_BOOL);
mirror ID_INT (MMX_INT);
mirror ID_STRING (MMX_STRING);
mirror ID_OSTREAM (MMX_OSTREAM);
mirror ID_CROSS (MMX_CROSS);
mirror ID_FUNCTION (MMX_FUNCTION);
mirror ID_ALIAS (MMX_ALIAS);
mirror ID_FORALL (MMX_FORALL);
mirror ID_EXISTS (MMX_EXISTS);
mirror ID_IMPLIES (MMX_IMPLIES);
mirror ID_AND (MMX_AND);
mirror ID_OR (MMX_OR);
mirror ID_NOT (MMX_NOT);

value VAL_CLASS (ID_CLASS, ID_CLASS);
value VAL_GENERIC (ID_GENERIC, ID_CLASS);
value VAL_BOOL (ID_BOOL, ID_CLASS);
value VAL_INT (ID_INT, ID_CLASS);
value VAL_STRING (ID_STRING, ID_CLASS);
value VAL_OSTREAM (ID_OSTREAM, ID_CLASS);

/******************************************************************************
* Miscellaneous
******************************************************************************/

symbol CONV_FUNCTION ("0#");
symbol CONV_ARGUMENT ("1#");
symbol CONV_APPLY ("apply#");
symbol CONV_CROSS ("cross#");
symbol CONV_IGNORE ("ignore#");
symbol CONV_LAMBDA ("lambda#");
symbol CONV_UNALIAS ("unalias#");
symbol CONV_UNAND ("unand#");
symbol CONV_UNCROSS ("uncross#");

symbol  MMX_VOID ("Void");
generic ID_VOID= list (ID_CROSS);
value   VAL_VOID (ID_VOID, ID_CLASS);
value   VAL_NONE= value (generic (), ID_VOID);

} // namespace mmx
